local RayUI, E, _, V, P, G = unpack(select(2, ...))
local RF = RayUI:NewModule('RayUIFocuser', 'AceEvent-3.0')

local _G, pairs = _G, pairs
local InCombatLockdown = InCombatLockdown
local CreateFrame = CreateFrame
local SetOverrideBindingClick = SetOverrideBindingClick

local modifier = 'shift' -- shift, alt or ctrl
local mouseButton = '1' -- 1 = left, 2 = right, 3 = middle, 4 and 5 = thumb buttons if there are any
local waitforHook = {}

function RF:HookOuf()
    for _, object in pairs(_G.ElvUF.objects) do self:SetFocusHotkey(object) end
end

function RF:SetFocusHotkey(frame)
    if InCombatLockdown() then
        if not frame.FocuserHooked then waitforHook[frame] = true end
    else
        if not frame.FocuserHooked then
            frame:SetAttribute(modifier .. '-type' .. mouseButton, 'focus')
            frame.FocuserHooked = true
        end
        waitforHook[frame] = nil
    end
end

function RF:PLAYER_REGEN_ENABLED()
    if not InCombatLockdown() then for frame in pairs(waitforHook) do self:SetFocusHotkey(frame) end end
end

function RF:Initialize()
    if not E.db.rayui.misc.focuser then return end
    local FocuserButton = CreateFrame('CheckButton', 'FocuserButton', E.UIParent, 'SecureActionButtonTemplate')
    FocuserButton:SetAttribute('type1', 'macro')
    FocuserButton:SetAttribute('macrotext', '/focus mouseover')
    SetOverrideBindingClick(FocuserButton, true, modifier .. '-BUTTON' .. mouseButton, 'FocuserButton')
    self:HookOuf()

    self:RegisterEvent('PLAYER_REGEN_ENABLED')
    self:RegisterEvent('GROUP_ROSTER_UPDATE', 'HookOuf')
end

RayUI:RegisterModule(RF:GetName())
