local RayUI, E, _, V, P, G = unpack(select(2, ...))
local RS = RayUI:GetModule('RayUISkins')

local _G, pairs = _G, pairs

function RS:WeakAuras()
    local function Skin_WeakAuras(frame, ftype)
        if frame.icon then
            if frame.cooldown then
                frame.cooldown.CooldownOverride = 'actionbar'
                E:RegisterCooldown(frame.cooldown)

                frame.cooldown:SetHideCountdownNumbers(false)
            end
        end
    end

    local WeakAuras = _G.WeakAuras
    local Create_Icon, Modify_Icon = WeakAuras.regionTypes.icon.create, WeakAuras.regionTypes.icon.modify
    local Create_AuraBar, Modify_AuraBar = WeakAuras.regionTypes.aurabar.create, WeakAuras.regionTypes.aurabar.modify

    WeakAuras.regionTypes.icon.create = function(parent, data)
        local region = Create_Icon(parent, data)
        Skin_WeakAuras(region, 'icon')
        return region
    end

    WeakAuras.regionTypes.aurabar.create = function(parent)
        local region = Create_AuraBar(parent)
        Skin_WeakAuras(region, 'aurabar')
        return region
    end

    WeakAuras.regionTypes.icon.modify = function(parent, region, data)
        Modify_Icon(parent, region, data)
        Skin_WeakAuras(region, 'icon')
    end

    WeakAuras.regionTypes.aurabar.modify = function(parent, region, data)
        Modify_AuraBar(parent, region, data)
        Skin_WeakAuras(region, 'aurabar')
    end

    for weakAura, _ in pairs(WeakAuras.regions) do
        if WeakAuras.regions[weakAura].regionType == 'icon' or WeakAuras.regions[weakAura].regionType == 'aurabar' then
            Skin_WeakAuras(WeakAuras.regions[weakAura].region, WeakAuras.regions[weakAura].regionType)
        end
    end
end

RS:RegisterSkinForPreload('WeakAuras', RS.WeakAuras)
